link-vmlinux.sh 5.2 KB

123456789101112131415161718192021222324252627282930313233343536373839404142434445464748495051525354555657585960616263646566676869707172737475767778798081828384858687888990919293949596979899100101102103104105106107108109110111112113114115116117118119120121122123124125126127128129130131132133134135136137138139140141142143144145146147148149150151152153154155156157158159160161162163164165166167168169170171172173174175176177178179180181182183184185186187188189190191192193194195196197198199200201202203204205206207208209210211212213214
  1. #!/bin/sh
  2. #
  3. # link vmlinux
  4. #
  5. # vmlinux is linked from the objects selected by $(KBUILD_VMLINUX_INIT) and
  6. # $(KBUILD_VMLINUX_MAIN). Most are built-in.o files from top-level directories
  7. # in the kernel tree, others are specified in arch/$(ARCH)/Makefile.
  8. # Ordering when linking is important, and $(KBUILD_VMLINUX_INIT) must be first.
  9. #
  10. # vmlinux
  11. # ^
  12. # |
  13. # +-< $(KBUILD_VMLINUX_INIT)
  14. # | +--< init/version.o + more
  15. # |
  16. # +--< $(KBUILD_VMLINUX_MAIN)
  17. # | +--< drivers/built-in.o mm/built-in.o + more
  18. # |
  19. # +-< ${kallsymso} (see description in KALLSYMS section)
  20. #
  21. # vmlinux version (uname -v) cannot be updated during normal
  22. # descending-into-subdirs phase since we do not yet know if we need to
  23. # update vmlinux.
  24. # Therefore this step is delayed until just before final link of vmlinux.
  25. #
  26. # System.map is generated to document addresses of all kernel symbols
  27. # Error out on error
  28. set -e
  29. # Nice output in kbuild format
  30. # Will be supressed by "make -s"
  31. info()
  32. {
  33. if [ "${quiet}" != "silent_" ]; then
  34. printf " %-7s %s\n" ${1} ${2}
  35. fi
  36. }
  37. # Link of vmlinux.o used for section mismatch analysis
  38. # ${1} output file
  39. modpost_link()
  40. {
  41. ${LD} ${LDFLAGS} -r -o ${1} ${KBUILD_VMLINUX_INIT} \
  42. --start-group ${KBUILD_VMLINUX_MAIN} --end-group
  43. }
  44. # Link of vmlinux
  45. # ${1} - optional extra .o files
  46. # ${2} - output file
  47. vmlinux_link()
  48. {
  49. local lds="${objtree}/${KBUILD_LDS}"
  50. if [ "${SRCARCH}" != "um" ]; then
  51. ${LD} ${LDFLAGS} ${LDFLAGS_vmlinux} -o ${2} \
  52. -T ${lds} ${KBUILD_VMLINUX_INIT} \
  53. --start-group ${KBUILD_VMLINUX_MAIN} --end-group ${1}
  54. else
  55. ${CC} ${CFLAGS_vmlinux} -o ${2} \
  56. -Wl,-T,${lds} ${KBUILD_VMLINUX_INIT} \
  57. -Wl,--start-group \
  58. ${KBUILD_VMLINUX_MAIN} \
  59. -Wl,--end-group \
  60. -lutil ${1}
  61. rm -f linux
  62. fi
  63. }
  64. # Create ${2} .o file with all symbols from the ${1} object file
  65. kallsyms()
  66. {
  67. info KSYM ${2}
  68. local kallsymopt;
  69. if [ -n "${CONFIG_KALLSYMS_ALL}" ]; then
  70. kallsymopt=--all-symbols
  71. fi
  72. kallsymopt="${kallsymopt} --page-offset=$CONFIG_PAGE_OFFSET"
  73. local aflags="${KBUILD_AFLAGS} ${KBUILD_AFLAGS_KERNEL} \
  74. ${NOSTDINC_FLAGS} ${LINUXINCLUDE} ${KBUILD_CPPFLAGS}"
  75. ${NM} -n ${1} | \
  76. scripts/kallsyms ${kallsymopt} | \
  77. ${CC} ${aflags} -c -o ${2} -x assembler-with-cpp -
  78. }
  79. # Create map file with all symbols from ${1}
  80. # See mksymap for additional details
  81. mksysmap()
  82. {
  83. ${CONFIG_SHELL} "${srctree}/scripts/mksysmap" ${1} ${2}
  84. }
  85. # Delete output files in case of error
  86. trap cleanup SIGHUP SIGINT SIGQUIT SIGTERM ERR
  87. cleanup()
  88. {
  89. rm -f .old_version
  90. rm -f .tmp_System.map
  91. rm -f .tmp_kallsyms*
  92. rm -f .tmp_version
  93. rm -f .tmp_vmlinux*
  94. rm -f System.map
  95. rm -f vmlinux
  96. rm -f vmlinux.o
  97. }
  98. #
  99. #
  100. # Use "make V=1" to debug this script
  101. case "${KBUILD_VERBOSE}" in
  102. *1*)
  103. set -x
  104. ;;
  105. esac
  106. if [ "$1" = "clean" ]; then
  107. cleanup
  108. exit 0
  109. fi
  110. # We need access to CONFIG_ symbols
  111. . ./.config
  112. #link vmlinux.o
  113. info LD vmlinux.o
  114. modpost_link vmlinux.o
  115. # modpost vmlinux.o to check for section mismatches
  116. ${MAKE} -f "${srctree}/scripts/Makefile.modpost" vmlinux.o
  117. # Update version
  118. info GEN .version
  119. if [ ! -r .version ]; then
  120. rm -f .version;
  121. echo 1 >.version;
  122. else
  123. mv .version .old_version;
  124. expr 0$(cat .old_version) + 1 >.version;
  125. fi;
  126. # final build of init/
  127. ${MAKE} -f "${srctree}/scripts/Makefile.build" obj=init
  128. kallsymso=""
  129. kallsyms_vmlinux=""
  130. if [ -n "${CONFIG_KALLSYMS}" ]; then
  131. # kallsyms support
  132. # Generate section listing all symbols and add it into vmlinux
  133. # It's a three step process:
  134. # 1) Link .tmp_vmlinux1 so it has all symbols and sections,
  135. # but __kallsyms is empty.
  136. # Running kallsyms on that gives us .tmp_kallsyms1.o with
  137. # the right size
  138. # 2) Link .tmp_vmlinux2 so it now has a __kallsyms section of
  139. # the right size, but due to the added section, some
  140. # addresses have shifted.
  141. # From here, we generate a correct .tmp_kallsyms2.o
  142. # 2a) We may use an extra pass as this has been necessary to
  143. # woraround some alignment related bugs.
  144. # KALLSYMS_EXTRA_PASS=1 is used to trigger this.
  145. # 3) The correct ${kallsymso} is linked into the final vmlinux.
  146. #
  147. # a) Verify that the System.map from vmlinux matches the map from
  148. # ${kallsymso}.
  149. kallsymso=.tmp_kallsyms2.o
  150. kallsyms_vmlinux=.tmp_vmlinux2
  151. # step 1
  152. vmlinux_link "" .tmp_vmlinux1
  153. kallsyms .tmp_vmlinux1 .tmp_kallsyms1.o
  154. # step 2
  155. vmlinux_link .tmp_kallsyms1.o .tmp_vmlinux2
  156. kallsyms .tmp_vmlinux2 .tmp_kallsyms2.o
  157. # step 2a
  158. if [ -n "${KALLSYMS_EXTRA_PASS}" ]; then
  159. kallsymso=.tmp_kallsyms3.o
  160. kallsyms_vmlinux=.tmp_vmlinux3
  161. vmlinux_link .tmp_kallsyms2.o .tmp_vmlinux3
  162. kallsyms .tmp_vmlinux3 .tmp_kallsyms3.o
  163. fi
  164. fi
  165. info LD vmlinux
  166. vmlinux_link "${kallsymso}" vmlinux
  167. info SYSMAP System.map
  168. mksysmap vmlinux System.map
  169. # step a (see comment above)
  170. if [ -n "${CONFIG_KALLSYMS}" ]; then
  171. mksysmap ${kallsyms_vmlinux} .tmp_System.map
  172. if ! cmp -s System.map .tmp_System.map; then
  173. echo Inconsistent kallsyms data
  174. echo echo Try "make KALLSYMS_EXTRA_PASS=1" as a workaround
  175. cleanup
  176. exit 1
  177. fi
  178. fi
  179. # We made a new kernel - delete old version file
  180. rm -f .old_version